;; -*- mode: scheme; coding: utf-8 -*-

;;;; Copyright (C) 2011, 2012
;;;; Free Software Foundation, Inc.

;;;; This library is free software: you can redistribute it and/or
;;;; modify it under the terms of the GNU General Public License as
;;;; published by the Free Software Foundation, either version 3 of
;;;; the License, or (at your option) any later version.

;;;; This library is distributed in the hope that it will be useful, but
;;;; WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;;; General Public License for more details.

;;;; You should have received a copy of the GNU General Public License
;;;; along with this library.  If not, see <http://www.gnu.org/licenses/>.
;;;;

;;; Commentary:

;;; Code:

(define-module (gtk colours)
  ;; guile
  :use-module (srfi srfi-1)
  ;; common
  :use-module (system aglobs)
  :use-module (system config)
  :export (palette
	   colour-set
	   colour-set-bg
	   colour-set-border
	   colour-set-fg
	   colour-set-name
	   colour-set-ids
	   colour-set-names))

(define palette #f)
(define colour-set #f)
(define colour-set-bg #f)
(define colour-set-border #f)
(define colour-set-fg #f)
(define colour-set-name #f)

(define colour-set-ids #f)
(define colour-set-names #f)

(eval-when (compile load eval)
  (let* ((whereami (dirname (search-path %load-path "gtk/colours.scm")))
	 ;; (name . (background border foreground))
	 (sets (sys/read (string-append whereami "/colour-sets"))))
    (set! palette sets)
    (set! colour-set
	  (lambda (id) (assq-ref sets id)))
    (set! colour-set-bg
	  (lambda (id) (list-ref (colour-set id) 0)))
    (set! colour-set-border
	  (lambda (id) (list-ref (colour-set id) 1)))
    (set! colour-set-fg
	  (lambda (id) (list-ref (colour-set id) 2)))
    (set! colour-set-name
	  (lambda (id) (list-ref (colour-set id) 3)))
    (set! colour-set-ids
	  (lambda () (filter-map (lambda (set) (car set)) palette)))
    (set! colour-set-names
	  (lambda () (filter-map (lambda (entry) (dimfi entry) (colour-set-name (car entry))) palette)))))


;;;
;;; 
;;;


#!

(use-modules (gtk colours))
(reload-module (resolve-module '(gtk colours)))

palette

(colour-set 1)
(colour-set-bg 1)
(colour-set-border 1)
(colour-set-fg 1)
(colour-set-name 1)

(colour-set-ids)
(colour-set-names)


;; Gtk widget states

'((normal GTK_STATE_NORMAL 0)
  (active GTK_STATE_ACTIVE 1)
  (prelight GTK_STATE_PRELIGHT 2) 
  (selected GTK_STATE_SELECTED 3)
  (insensitive GTK_STATE_INSENSITIVE 4))

!#