;; -*- mode: scheme; coding: utf-8 -*-

;;;; Copyright (C) 2011, 2012
;;;; Free Software Foundation, Inc.
;;;;
;;;; This library is free software; you can redistribute it and/or
;;;; modify it under the terms of the GNU General Public License as
;;;; published by the Free Software Foundation; either version 3 of
;;;; the License, or (at your option) any later version.
;;;; 
;;;; This library is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;;; General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with this library; if not, write to the Free Software
;;;; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
;;;; 02110-1301 USA
;;;;

;;; Commentary:

;;; Code:

(define-module (system aglobs)
  :export (aglobs
	   aglobs/get
	   aglobs/set
	   aglobs/display
	   dimfi))

(define aglobs #f)
(define aglobs/get #f)
(define aglobs/set #f)

(eval-when (compile load eval)
  (set! aglobs (list))
  (set! aglobs/get
	(lambda (key)
	  ;; (format #t "~S~%" aglobs)
	  (case key
	    ((all) aglobs)
	    (else (assq-ref aglobs key)))))
  (set! aglobs/set
	(lambda (key value)
	  ;; (format #t "~S~%" aglobs)
	  (set! aglobs
		(assq-set! aglobs key value)))))


;;;
;;; GUI based apps should have a splash, but this is a simple user
;;; feedback mecanism in case he/she has launched the application from
;;; a terminal
;;;

(define* (aglobs/display message port #:optional (nl #t))
  (display message port)
  (if nl (display "\n")))

(define (dimfi . items)
  ;; if the first item is a port, we use it.
  (if (port? (car items))
      (let ((p (car items)))
	(for-each (lambda (item)
		    (write item p) (display " " p))
	    (cdr items))
	(display "\n" p))
      (begin
	(for-each (lambda (item)
		    (write item) (display " "))
	    items)
	(display "\n")))
  (car (last-pair items)))


#!

(use-modules (system aglobs))
(reload-module (resolve-module '(system aglobs)))


!#
