;; -*- mode: scheme; coding: utf-8 -*-

;;;; Copyright (C) 2011, 2012
;;;; Free Software Foundation, Inc.
;;;;
;;;; This library is free software; you can redistribute it and/or
;;;; modify it under the terms of the GNU General Public License as
;;;; published by the Free Software Foundation; either version 3 of
;;;; the License, or (at your option) any later version.
;;;; 
;;;; This library is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;;; General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with this library; if not, write to the Free Software
;;;; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
;;;; 02110-1301 USA
;;;;

;;; Commentary:

;; This code has been writen by Mark H. Weaver - one of the actual
;; [2013] guile's co-maintainer - in order to reproduce a bug I [David
;; R. Pirotte] only detected on a powerfull server [it was not
;; reproducable on low to medium end computers.  Since it served as a
;; basis to then check the patch he wrote for guile 2.0.9, I decided
;; to make a module with his test, that I can use any time to check
;; that users are running a popen thread safe guile version.

;;; Code:


(define-module (tests thread-safe-popen)
  :use-module (ice-9 popen)
  :export (thread-safe-popen-test))

(define (thread-safe-popen-test)
  (map (lambda (_)
         (call-with-new-thread
	  (lambda ()
	    (let loop ()
	      (let ((pipe (open-pipe* OPEN_READ "echo" "foo")))
		(read pipe)
		(close-pipe pipe))
	      (loop)))))
       (iota (current-processor-count))))

#!

(use-modules (tests thread-safe-popen))
(reload-module (resolve-module '(tests thread-safe-popen)))

(thread-safe-popen-test)

!#
